# Note that this is NOT a relocatable package
%define name	mc
%define ver	4.5.42
%define rel	16ml
%define prefix	/usr

Summary: A user-friendly file manager and visual shell.
Name:      %{name}
Version:   %ver
Release:   %rel
Serial:    2004091701
Copyright: GPL
Group: User Interface/Desktops
Source0: ftp://ftp.gnome.org/pub/GNOME/sources/mc/mc-%{PACKAGE_VERSION}.tar.gz
Source1: mc-4.5.42-doc-gmc.tar.gz
Source3:   distribution.links
Source4:   distribution.png
Source5:   mc-gfm
#NoSource: 0
URL:       http://www.gnome.org/mc/
BuildRoot: /var/tmp/mc-%{PACKAGE_VERSION}-root
Requires:  pam >= 0.59, distro, distribution-X

Prereq:    /sbin/chkconfig

Patch0:    mc-4.5.35-xtermcolor.patch
Patch1:    mc-4.5.36-mimekeys.patch
Patch2:    mc-4.5.42-ja.po.patch
Patch3:    mc-4.5.42-gmc-ctrl_q.patch
Patch4:    mc-4.5.42-gfm.patch
patch5:    mc-4.5.42-gmc-root-error.patch
patch6:	   mc-4.5.42-gmc-desktoptext.patch
patch7:	   mc-CVE-CAN-2003-1023.patch
patch8:	   mc-CVE-CAN-2004-0226.patch
patch9:    mc-CVE-CAN-2004-0494.patch

%description
Midnight Commander is a visual shell much like a file manager, only
with many more features.  It is a text mode application, but it also
includes mouse support if you are running GPM. Midnight Commander's
coolest features are its abilities to FTP, view tar and zip files, and
to poke into RPMs for specific files.

%package -n gmc
Summary: The GNOME version of the Midnight Commander file manager.
Requires: mc >= %{PACKAGE_VERSION}
Group: User Interface/Desktops
%description -n gmc
GMC (GNU Midnight Commander) is a file manager based on the terminal
version of Midnight Commander, with the addition of a GNOME GUI
desktop front-end. GMC can FTP, view TAR and compressed files and look
into RPMs for specific files.

Install gmc if you're installing GNOME and you'd like to use the
Midnight Commander file manager with it.

%package -n mcserv
Summary: Server for the Midnight Commander network file management system.
Group: System Environment/Daemons
Requires: portmap
%description -n mcserv
The Midnight Commander file management system will allow you to
manipulate the files on a remote machine as if they were local.  This
is only possible if the remote machine is running the mcserv server
program.  Mcserv provides clients running Midnight Commander with
access to the host's file systems.

Install mcserv on machines if you want to access their file systems
remotely using the Midnight Commander file management system.

%prep
%setup -q
%patch -p1 -b .xtermcolor
%patch1 -p1 -b .mimekeys
%patch2 -p1 -b .orig
%patch3 -p1 -b .ctrl_q
%patch5 -p1 -b .root
%patch6 -p1 -b .desktoptext
%patch7 -p1 -b .CVE-CAN-2003-1023
%patch8 -p1 -b .CVE-CAN-2004-0226

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure \
        --prefix=%{prefix} --sysconfdir=/etc\
        --without-debug \
        --with-included-slang \
	--with-gnome

make

rm -rf gfm
cp -a gnome gfm
patch -p1 -b --suffix .gfm -s < %{PATCH4}

make -C gfm

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,pam.d,profile.d,X11/wmconfig}

make prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT/etc install
tar zxvf %{SOURCE1} -C $RPM_BUILD_ROOT%{prefix}/share/gnome/help
# make DESTDIR=$RPM_BUILD_ROOT install

strip $RPM_BUILD_ROOT/usr/bin/*
(cd icons; make prefix=$RPM_BUILD_ROOT%{prefix} install_icons)
install lib/mcserv.init $RPM_BUILD_ROOT/etc/rc.d/init.d/mcserv

install lib/mcserv.pamd $RPM_BUILD_ROOT/etc/pam.d/mcserv
install lib/{mc.sh,mc.csh} $RPM_BUILD_ROOT/etc/profile.d
install lib/mc.global $RPM_BUILD_ROOT/etc

# clean up this setuid problem for now
chmod 755 $RPM_BUILD_ROOT%{prefix}/lib/mc/bin/cons.saver

# copy turbo desktop default icons
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib/desktop-links/
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{prefix}/lib/desktop-links/
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{prefix}/share/pixmaps/mc/

# instarll gfm, filamaneger
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{prefix}/bin/gfm
install -m 755 gfm/plain-gmc $RPM_BUILD_ROOT%{prefix}/bin/plain-gfm

pushd $RPM_BUILD_ROOT/%{_libdir}/mc/extfs
patch -p5 -s < %{PATCH9}
rm -f *.orig
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post   -n mcserv
/sbin/chkconfig --add mcserv

%preun -n mcserv
/sbin/chkconfig --del mcserv

%post -n gmc
cat /usr/lib/desktop-links/distribution.links | sed -e "s|@DISTRIBUTION@|$(/sbin/dname -d)|" > /usr/lib/desktop-links/distribution.links.$$
mv -f /usr/lib/desktop-links/distribution.links.$$ /usr/lib/desktop-links/distribution.links

%files
%defattr(-, root, root)

%doc FAQ COPYING NEWS README
%{prefix}/bin/mc
%{prefix}/bin/mcedit
%{prefix}/bin/mcmfmt

%{prefix}/lib/mc/mc.ext
%{prefix}/lib/mc/mc.hint
%{prefix}/lib/mc/mc.hlp
%{prefix}/lib/mc/mc.lib
%{prefix}/lib/mc/mc.menu
%{prefix}/lib/mc/bin/cons.saver
%{prefix}/lib/mc/extfs/*
%{prefix}/lib/mc/syntax/*
%{prefix}/lib/mc/term/*
%{prefix}/man/man1/*
%config /etc/profile.d/*
%config /etc/mc.global
%dir %{prefix}/lib/mc
%dir %{prefix}/lib/mc/bin

%files -n mcserv
%defattr(-, root, root)

%config /etc/pam.d/mcserv
%config /etc/rc.d/init.d/mcserv
%attr(-, root, man)  %{prefix}/man/man8/mcserv.8
%{prefix}/bin/mcserv

%files -n gmc
%defattr(-, root, root)
%doc lib/README.desktop
%{prefix}/bin/gmc
%{prefix}/bin/plain-gmc
%{prefix}/bin/gfm
%{prefix}/bin/plain-gfm
%{prefix}/share/idl/*
%{prefix}/lib/mc/layout
%{prefix}/lib/mc/mc-gnome.ext
%{prefix}/share/pixmaps/mc/*
%{prefix}/share/mime-info/mc.keys
%{prefix}/share/gnome/help/gmc/*
%{prefix}/share/locale/*/*/*
%config /etc/CORBA/servers/*
%dir %{prefix}/lib/mc/desktop-scripts
%dir %{prefix}/lib/desktop-links
%{prefix}/lib/desktop-links/distribution.links


%changelog
* Fri Sep 17 2004 Yasuma Takeda <yasuma@miraclelinux.com> 4.5.51-43ml
- fix extfs script (CAN-2004-0494)

* Fri Jun 11 2004 Akinobu Mita <mita@miraclelinux.com> 4.5.42-15
- fix various buffer overflows, temporary file creation problems
  and one format string vulneratibity (CAN-2004-0226)

* Thu Jan 29 2004 Seiichi Ikarashi <ikarashi@miraclelinux.com>
- add mc-CVE-CAN-2003-1023.patch

* Tue Apr 19 2001 Yuji Oishi <yoishi@miraclelinux.com>
- change miracle icon image again(distribution.png)

* Tue Apr 11 2001 Yuji Oishi <yoishi@miraclelinux.com>
- change miracle icon image (distribution.png)

* Fri Jul 7 2000 Go Taniguchi <go@turbolinux.co.jp>
- use distro format

* Wed Apr  5 2000 Go Taniguchi <go@turbolinux.co.jp>
- desktop icon text use gettext
- add gmc HELP document

* Thu Mar 16 2000 Takeshi Aihana <aihana@turbolinux.co.jp>
- modified TurboLinux Desktop icons
- modified TurboLinux Homepage url

* Tue Mar 14 2000 Takeshi Aihana <aihana@turbolinux.co.jp>
- modified TurboLinux Desktop links

* Tue Mar 14 2000 Go Taniguchi <go@turbolinux.co.jp>
- gnome_check_super_user modal to modaless

* Tue Feb 8 2000 Go Taniguchi <go@turbolinux.co.jp>
- fix ja.po [IEE]
- fix gmc ctrl-w handler

* Wed Jan 12 2000 Go Taniguchi <go@turbolinux.co.jp>
- fix gfm. close child window, broken main window

* Sun Jan 9 2000 Go Taniguchi <go@turbolinux.co.jp>
- make gfm filemanager , using plane-gmc for my clients.

* Fri Dec 31 1999 Go Taniguchi <go@turbolinux.co.jp>
- updated to 4.5.42

* Fri Nov 12 1999 Go Taniguchi <taniguchi@arcbrain.co.jp>
- updated to 4.5.41

* Fri Oct 22 1999 Go Taniguchi <taniguchi@arcbrain.co.jp>
- updated to 4.5.40

* Fri Sep 25 1999 Bill Nottingham <notting@redhat.com>
- chkconfig --del in %preun, not %postun

* Fri Sep 24 1999 Go Taniguchi <taniguchi@arcbrain.co.jp>
- added TLJicon.xpm and turbolinux.links for TurboLinuxJ 4.0

* Wed Sep 22 1999 Michael Fulbright <drmike@redhat.com>
- updated to 4.5.39-pre9

* Wed Aug 04 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved configure to setup
- buildrequires gpm-devel so mouse works in console

* Wed Jul 22 1999 Michael Fulbright <drmike@redhat.com>
- added ${prefix}/lib/mc/syntax to mc file list
- turned off samba support

* Wed Jul  7 1999 Jonathan Blandford <jrb@redhat.com>
- updated mc to work with mc 4.5.36.  Thanks to Brian Ryner
  <bryner@uiuc.edu> for providing the patch.

* Mon Apr 19 1999 Michael Fulbright <drmike@redhat.com>
- removed rpm menu defs - we depend on gnorpm for these
- fixed bug that caused crash if group doesnt exist for file

* Thu Apr 15 1999 Michael Fulbright <drmike@redhat.com>
- cleanup several dialogs

* Mon Apr 12 1999 Michael Fulbright <drmike@redhat.com>
- true version 4.5.30

* Fri Apr 09 1999 Michael Fulbright <drmike@redhat.com>
- version pre-4.5.30 with patch to make this link on alpha properly
  Mark as version 0.7 to denote not the official 4.5.30 release

* Tue Apr 06 1999 Preston Brown <pbrown@redhat.com>
- strip binaries

* Wed Mar 31 1999 Michael Fulbright <drmike@redhat.com>
- fixed errata support URL

* Tue Mar 25 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.29
- added default desktop icons for Red Hat desktop
- added redhat-logos to requirements
- added README.desktop to doc list for gmc
- added locale data

* Fri Mar 25 1999 Preston Brown <pbrown@redhat.com>
- patched so that TERM variable set to xterm produces color

* Mon Mar 22 1999 Michael Fulbright <drmike@redhat.com>
- made sure /etc/pam.d/mcserv has right permissions

* Thu Mar 18 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.27

* Tue Mar 16 1999 Michael Fulbright <drmike@redhat.com>
- fix'd icon display problem

* Sun Mar 14 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.25 AND 4.5.26

* Wed Mar 10 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.24

* Mon Feb 15 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.16
- removed mc.keys from mc file list

* Fri Feb 12 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.14
- fixed file list

* Sat Feb 06 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.11

* Wed Feb 03 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.10

* Fri Jan 22 1999 Michael Fulbright <drmike@redhat.com>
- added metadata to gmc file list

* Mon Jan 18 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.9

* Wed Jan 06 1999 Michael Fulbright <drmike@redhat.com>
- version 4.5.6

* Wed Dec 16 1998 Michael Fulbright <drmike@redhat.com>
- updated for GNOME freeze

* Thu Aug 20 1998 Michael Fulbright <msf@redhat.com>
- rebuilt against gnome-libs 0.27 and gtk+-1.1

* Thu Jul 09 1998 Michael Fulbright <msf@redhat.com>
- made cons.saver not setuid

* Sun Apr 19 1998 Marc Ewing <marc@redhat.com>
- removed tkmc

* Wed Apr 8 1998 Marc Ewing <marc@redhat.com>
- add %{prefix}/lib/mc/layout to gmc

* Tue Dec 23 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>
- added --without-debug to configure,
- modification in %build and %install and cosmetic modification in packages
  headers,
- added %%{PACKAGE_VERSION} macro to Buildroot,
- removed "rm -rf $RPM_BUILD_ROOT" from %prep.
- removed Packager field.

* Thu Dec 18 1997 Michele Marziani <marziani@fe.infn.it>
- Merged spec file with that from RedHat-5.0 distribution
  (now a Hurricane-based distribution is needed)
- Added patch for RPM script (didn't always work with rpm-2.4.10)
- Corrected patch for mcserv init file (chkconfig init levels)
- Added more documentation files on termcap, terminfo, xterm

* Thu Oct 30 1997 Michael K. Johnson <johnsonm@redhat.com>

- Added dependency on portmap

* Wed Oct 29 1997 Michael K. Johnson <johnsonm@redhat.com>

- fixed spec file.
- Updated to 4.1.8

* Sun Oct 26 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- updated to 4.1.6
- added %attr macros in %files,
- a few simplification in %install,
- removed glibc patch,
- fixed installing /etc/X11/wmconfig/tkmc.

* Thu Oct 23 1997 Michael K. Johnson <johnsonm@redhat.com>

- updated to 4.1.5
- added wmconfig

* Wed Oct 15 1997 Erik Troan <ewt@redhat.com>

- chkconfig is for mcserv package, not mc one

* Tue Oct 14 1997 Erik Troan <ewt@redhat.com>

- patched init script for chkconfig
- don't turn on the service by default

* Fri Oct 10 1997 Michael K. Johnson <johnsonm@redhat.com>

- Converted to new PAM conventions.
- Updated to 4.1.3
- No longer needs glibc patch.

* Thu May 22 1997 Michele Marziani <marziani@fe.infn.it>

- added support for mc alias in /etc/profile.d/mc.csh (for csh and tcsh)
- lowered number of SysV init scripts in /etc/rc.d/rc[0,1,6].d
  (mcserv needs to be killed before inet)
- removed all references to $RPM_SOURCE_DIR
- restored $RPM_OPT_FLAGS when compiling
- minor cleanup of spec file: redundant directives and comments removed

* Sun May 18 1997 Michele Marziani <marziani@fe.infn.it>

- removed all references to non-existent mc.rpmfs
- added mcedit.1 to the %files section
- reverted to un-gzipped man pages (RedHat style)
- removed double install line for mcserv.pamd

* Tue May 13 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- added new rpmfs script,
- removed mcfn_install from mc (adding mc() to bash enviroment is in
  /etc/profile.d/mc.sh),
- /etc/profile.d/mc.sh changed to %config,
- removed %{prefix}/lib/mc/bin/create_vcs,
- removed %{prefix}/lib/mc/term.

* Wed May 9 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- changed source url,
- fixed link mcedit to mc,

* Tue May 7 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- new version 3.5.27,
- %dir %{prefix}/lib/mc/icons and icons removed from tkmc,
- added commented xmc part.

* Tue Apr 22 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- FIX spec:
   - added URL field,
   - in mc added missing %{prefix}/lib/mc/mc.ext, %{prefix}/lib/mc/mc.hint,
     %{prefix}/lib/mc/mc.hlp, %{prefix}/lib/mc/mc.lib, %{prefix}/lib/mc/mc.menu.

* Fri Apr 18 1997 Tomasz Koczko <kloczek@rudy.mif.pg.gda.pl>

- added making packages: tkmc, mcserv (xmc not work yet),
- gziped man pages,
- added /etc/pamd.d/mcserv PAM config file.
- added instaling icons,
- added /etc/profile.d/mc.sh,
- in %doc added NEWS README,
- removed %{prefix}/lib/mc/FAQ,
- added mcserv.init script for mcserv (start/stop on level 86).
